
#include "glue_transformation.h"  

//#include "glue_expr_util.h"
#include <iostream>

#define DEBUG 1
//using namespace glue;

#if 0
  /** Each time this function is invoked, it increases the bguard_counter by 1, and returns the following block of code

     if(glue_bguard_)
     {
     atomic_end;
     atomic_begin;
     } 
     
     x : if glue_bguard_XX goto w
     y : atomic_end
     z : atomic_begin
     w : 
     ****/

      
     void satomic_transformationt::get_guarded_atomic_gadget(goto_programt& result)
     {
       
       bguard_counter++;

       goto_programt x;
       goto_programt y;
       goto_programt z;
       goto_programt w;
       goto_programt::targett tmp_x = x.add_instruction();
       goto_programt::targett tmp_y = y.add_instruction();
       goto_programt::targett tmp_z = z.add_instruction();
       goto_programt::targett tmp_w = w.add_instruction();


       //declare a boolean guard for the program point named "glue_bguard_XX" where XX is the counter

       symbolt bguard;
       std::stringstream ss;
       ss << "glue_bguard_"<< bguard_counter;
       
       const irep_idt tmp_name = ss.str();
         
       bguard.is_lvalue=true;
       bguard.is_static_lifetime = true;
       bguard.is_thread_local= false;
       bguard.type = bool_typet();
       bguard.base_name=tmp_name;
       std::stringstream ss1;
       ss1 << "c::" << ss.str();
       bguard.name=ss1.str();
       bguard.mode=ID_C;
       

       

       context_out.add(bguard);

       tmp_x->make_goto(tmp_w);
       
       tmp_x->guard = bguard.symbol_expr();
      
       tmp_y->make_atomic_end();
       tmp_z->make_atomic_begin();
       tmp_w->make_skip();
       
       result.destructive_append(x);
       result.destructive_append(y);
       result.destructive_append(z);
       result.destructive_append(w);
       

     }

/********************************************************************************
Function : apply_transformation

Input : None

Output : None

Purpose : Transform the member goto_functions "func_in" into "func_out" such that
      every program point  after the access to shared variable is protected
      inside a guarded atomic blocks. These guards can be set to true/false allowing/disallowing 
      the context switches at these program points.
      There is no need to have guarded atomic block immediately before the 
      access to a shared variable. If two access are in s1, s2 then

      s1
      x1:guarded atomic_end,atomic_begin

      x2:guarded atomic_end,atomic_begin

      s2
      x3:guarded atomic_end,atomic_begin

      If we insert the guarded atomic block before access to every shard variable then
      it would create a situation as depicted above where atomic block starting atx1 
      ends at x2 and no shared variable access is inside this block. Making such a block
      pointless and it introduces additional burden by introducing extra boolean guard.

*********************************************************************************/
     void satomic_transformationt::apply_transformation()
     {
       
#ifdef DEBUG
       std::cout << std::endl << "\nInside satomic_transformationt::apply_transformation\n" << std::endl;
#endif
       //Insert the atomic_begin at the start of main 
       goto_functionst::function_mapt::iterator main_it = func_out.function_map.find(func_out.main_id());
       if(main_it!=func_out.function_map.end())
       {
         

         goto_programt::targett inst = main_it->second.body.insert_before(main_it->second.body.instructions.begin());
           
         inst->make_atomic_begin();
         
       }
#ifdef DEBUG
       std::cout<< std::endl << "After transforming main" << std::endl;
#endif
       

       Forall_goto_functions(f_it,func_out)
       {
         if(f_it->second.body_available)
         {
           //forall_goto_program_instructions(i_it,f_it->second.body)
           //DO NOT use the macro forall_goto_program_instructions
           //as the increase in iterator is at non-uniform locations
           goto_programt::instructionst::iterator i_it = f_it->second.body.instructions.begin();
           while(i_it!=f_it->second.body.instructions.end())
           {
             // add the guarded atomic after access to a shared variable. 
             if(has_sharedvar_access(i_it->code,context_out) || has_sharedvar_access(i_it->guard,context_out))
             {
               goto_programt tmp_prog;
              // get_guarded_atomic_gadget(tmp_prog);
              // tmp_prog.instructions.push_back((*i_it));

               get_guarded_atomic_gadget(tmp_prog);
               goto_programt::targett curr_ins = i_it;
               i_it++;
               f_it->second.body.destructive_insert(i_it,tmp_prog);
             }
             else if(i_it->is_start_thread() || i_it->is_end_thread() || (i_it->function == ID_main && i_it->is_end_function()))
             {
               //if it is a start_thread/end_thread instruction or end_function in main then close the atomic section
               // that might have been started by the earlier guarded atomic gadget
               
               goto_programt::targett in_x =  f_it->second.body.insert_before(i_it);
              in_x->make_atomic_end();

              if(i_it->is_start_thread())
              {
                // if it is a start_thread then we need to start the atomic block as well
                goto_programt::targett in_x = f_it->second.body.insert_after(i_it);
                in_x->make_atomic_begin();
                i_it++; // after this increment i_it will point to the newly inserted atomic_begin 
              }
               

               i_it++;
             }
             else
             {
               i_it++;
             }
           }
           //update the indices of goto program instructions
           f_it->second.body.update();
         }

       }



     }

#endif

#if 0
/****************************************************************************\
 * Function : is_builtin_instruction
 *
 * Input : goto_programt::targett iterator "instr" to the instruction
 *
 * Output : true if the instruction pointed to by instr is an instruction
 * inside a builtin function, false otherwise
 *
 * Purpose :
 ****************************************************************************/


     bool satomic_transformationt::is_builtin_instruciton(const goto_programt::targett& instr) const
     {
       std::string str1("<built");

       std::string::size_type found =  instr->location.as_string().find(str1);

       if(found!=std::string::npos)
       {
         return true;
       }



#ifdef DEBUG
       std::cout << instr->location << std::endl;
#endif
       return false;

     }

#endif
  /*************************************************************************************

     Function : get_guarded_lock_gadget

     Input : a goto_program "result"

     Output : void 

     Purpose : result contains the following gadget

     x: if(glue_bguard_XX) //XX is a counter
     y: lock_release(glue_lock) (y and z in turn are gadgets for lock_release and lock_acquire
     z : lock_acquire(glue_lock)
     w : skip

     **************************************************************************************/
     void satomic_transformationt::get_guarded_lock_gadget(goto_programt & result,
                                                       goto_programt::targett & instr,
                                                       bool mod_orig)
     {
         bguard_counter++;

       goto_programt x;
       goto_programt y;
       goto_programt z;
       goto_programt w;
       goto_programt::targett tmp_x = x.add_instruction();
       goto_programt::targett tmp_w = w.add_instruction();


       //declare a boolean guard for the program point named "glue_bguard_XX" where XX is the counter

       symbolt bguard;
       std::stringstream ss;
       ss << GLUE_BGUARD << bguard_counter;
       
       const irep_idt tmp_name = ss.str();
         
       bguard.is_lvalue=true;
       bguard.is_static_lifetime = true;
       bguard.is_thread_local= false;
       bguard.type = bool_typet();
       bguard.base_name=tmp_name;
       std::stringstream ss1;
       ss1 << "c::" << ss.str();
       bguard.name=ss1.str();
       bguard.mode=ID_C;
       

       

       context_out.add(bguard);

       tmp_x->make_goto(tmp_w);
       
       
       tmp_x->guard = bguard.symbol_expr();
      
       get_lock_release_gadget(y,instr->function);
       get_lock_acquire_gadget(z,instr->function);

       
       tmp_w->make_skip();
       
       result.destructive_append(x);
       result.destructive_append(y);
       result.destructive_append(z);
       result.destructive_append(w);

        std::stringstream ss2;
         ss2 << GLUEAUX << GLUE_BGUARD << bguard_counter;
         const irep_idt tmp_comment = ss2.str();


       Forall_goto_program_instructions(r_it,result)
       {
         
        
         
         r_it->source_location = instr->source_location;
         r_it->function = instr->function;
        
         r_it->source_location.set_comment(tmp_comment);
       }

       if(mod_orig)
       {
         std::stringstream ss3;
         ss3 << GLUEORIG <<GLUE_BGUARD << bguard_counter;
         const irep_idt tmp_comment1 = ss3.str();
          instr->source_location.set_comment(tmp_comment1);
       }

       


     }

     /***************************************************************************************
     Function : get_lock_acquire_gadget

     Input : goto_programt& result

     Output : None

     Purpose : 
     return the following goto_program in result

     the following code should ensure re-entrant lock
     acquire(lock)

     x1 : atomic_begin
     x2 : assume lock==0 || lock == tid
     x3 : old_lock = lock
     x4 : lock = tid;
     
     x5 : atomic_end;
     ******************************************************************************/
     void satomic_transformationt::get_lock_acquire_gadget(goto_programt& result,
    		 const irep_idt& fname)
     {
       goto_programt x1;
       goto_programt::targett in_x1 = x1.add_instruction();
       in_x1->make_atomic_begin();

       goto_programt x2;
       goto_programt::targett in_x2 = x2.add_instruction();
       exprt e = or_exprt(equal_exprt(glue_lock.symbol_expr(),from_integer(0,glue_lock.type)),
                       equal_exprt(glue_lock.symbol_expr(),thread_identifier.symbol_expr()));
       //insert e as the guard
       in_x2->make_assumption(e);


     

       //old_lock = lock
       goto_programt x3;
       goto_programt::targett in_x3 = x3.add_instruction();
       in_x3->make_assignment();
       in_x3->code = code_assignt(glue_old_lock.symbol_expr(),glue_lock.symbol_expr());


         goto_programt x4;
       goto_programt::targett in_x4 = x4.add_instruction();
       in_x4->make_assignment();
       // lock=tid 
       in_x4->code = code_assignt(glue_lock.symbol_expr(),thread_identifier.symbol_expr());
       prepend_to_instruction(in_x4,GLUELOCKING);

       goto_programt x5;
       goto_programt::targett in_x5 = x5.add_instruction();
       in_x5->make_atomic_end();

       result.destructive_append(x1);
       result.destructive_append(x2);
       result.destructive_append(x3);
       result.destructive_append(x4);
       result.destructive_append(x5);

       Forall_goto_program_instructions(rit,result)
       {
         make_auxiliary(rit);
         rit->function=fname;
       }


     }

     /******************************************************************************
     Function : get_lock_release_gadget

     Input : goto_programt & result

     Output : None

     Purpose : 
     in result, return the following code
       atomic begin
       assume lock==thread_id
     x : lock = old_lock
       atomic end

     basically release the re-entrant lock
     **********************************************************************************/
     void satomic_transformationt::get_lock_release_gadget(goto_programt & result,
    		 const irep_idt& fname)
     {

       goto_programt::targett r = result.add_instruction();
       r->make_atomic_begin();

       goto_programt::targett ra=result.add_instruction();
       exprt e = equal_exprt(glue_lock.symbol_expr(),
    		   thread_identifier.symbol_expr());
       ra->make_assumption(e);

       goto_programt::targett r1= result.add_instruction();

       r1->make_assignment();
       // lock = old_lock
       r1->code = code_assignt(glue_lock.symbol_expr(),glue_old_lock.symbol_expr());
       prepend_to_instruction(r1,GLUEUNLOCKING);
       goto_programt::targett r2=result.add_instruction();
       r2->make_atomic_end();

       Forall_goto_program_instructions(it,result)
       {
       make_auxiliary(it);
       it->function=fname;
       }

     }


     /************************************************************************************

     Function : get_thread_id_gadget

     Input : goto_programt& result

     Output : None

     Purpose : at the end "result" should contain the following code segment

     atomic_begin
     glue_thread_counter = glue_thread_counter + 1;
     glue_thread_id = glue_thread_counter;
     atomic_end

     This will be used at START_THREAD to instrument thread_id for every thread, this thread_id 
     is used for re-entrant lock-acquire


     *************************************************************************************/
     void satomic_transformationt::get_thread_id_gadget(goto_programt& result)
     {
       goto_programt tmp_ab;
       goto_programt::targett tmp_ab_ins = tmp_ab.add_instruction();
       tmp_ab_ins->make_atomic_begin();
       
       goto_programt tmp;
       goto_programt::targett tmp_ins = tmp.add_instruction();
       tmp_ins->make_assignment();
      
       
       //tcounter=tcounter+1;
       tmp_ins->code = code_assignt(thread_counter.symbol_expr(),plus_exprt(thread_counter.symbol_expr(),from_integer(1,thread_counter.type)));

       goto_programt tmp1;
       goto_programt::targett tmp1_ins = tmp.add_instruction();
       tmp1_ins->make_assignment();

       // tid = tcounter
       tmp1_ins->code = code_assignt(thread_identifier.symbol_expr(),thread_counter.symbol_expr());

       goto_programt tmp_ae;
       goto_programt::targett tmp_ae_ins = tmp_ae.add_instruction();
       tmp_ae_ins->make_atomic_end();

       result.destructive_append(tmp_ab);
       result.destructive_append(tmp);
       result.destructive_append(tmp1);
       result.destructive_append(tmp_ae);
       
      /*
       * These instructions should not be auxiliary. Only lock acq/rel should
       * be removed when moving from strong to weak atomicity. Theadid related gadgets
       * are required
       *
       * Forall_goto_program_instructions(rit,result)
       {
         make_auxiliary(rit);
       }*/

     }

     /****************************************************************************************

     Function : insert_thread_id

     Input : None

     Output : None

     Purpose : At the beginning of every thread, instrument thread_id using get_thread_id_gadget

     func_out will be the transformed goto_functions at the end.
     
     *****************************************************************************************/
     void satomic_transformationt::insert_thread_id()
     {

       
       goto_programt gadget_in_main;
       //Insert the thread_id gadget in main as it will be a main thread
       goto_functionst::function_mapt::iterator main_it = func_out.function_map.find(func_out.main_id());
       if(main_it!=func_out.function_map.end())
       {
         get_thread_id_gadget(gadget_in_main);
         main_it->second.body.destructive_append(gadget_in_main);
       }

       Forall_goto_functions(f_it,func_out)
       {
         if(f_it->second.body_available)
         {
           
           
           //forall_goto_program_instructions(i_it,f_it->second.body)
           goto_programt::instructionst::iterator i_it = f_it->second.body.instructions.begin();
           while(i_it!=f_it->second.body.instructions.end())
           {
             
             if(i_it->is_start_thread())
             {
               //whenever we encounter START_THREAD instruction, we have to insert thread_id gadget after it
               goto_programt tmp_prog;
               get_thread_id_gadget(tmp_prog);
               i_it++;
               f_it->second.body.destructive_insert(i_it,tmp_prog);
            

             }
                  
             


           }
           //Instructions are gathered in tmp_prog and then copied so as not to invalid iterators in Forall_goto_program_instructions
         f_it->second.body.update();
           
         }
       }
        


     }
    


     /************************************************************************************************
     Function : apply_transformation

     Input : None

     Output : None

     Purpose : func_out will contain the transformed program at the end. Program points before and after
     the access to every shared variable will be inside guarded lock region. These guards can be set to true/false
     to increase/decrease the size of lock region
     ************************************************************************************************/
void satomic_transformationt::apply_transformation()
   {
     
        
      

       Forall_goto_functions(f_it,func_out)
       {
         if(f_it->second.body_available)
         {
          // forall_goto_program_instructions(i_it,f_it->second.body)
           //CAN NOT use forall_goto_program_instructions macro
           // because increase in iterator value is non-uniform.
           // the increase happens before the lock gadget is inserted
           //where as it happens after in other cases
           goto_programt::instructionst::iterator i_it = f_it->second.body.instructions.begin();
           while(i_it!=f_it->second.body.instructions.end())
           {
             //If it is a branch instruction with a guard using shared variable
             //create a boolean temporary variable for it and then branch on the temporary
             //variable
             if( i_it->is_goto() &&
                 ! is_builtin_instruction(i_it) &&
                 has_sharedvar_access(i_it->guard,context_out) )
             {

               symbolt symbol;
                if(get_tmp_bool_symbol(symbol,i_it->function))
                {
                   goto_programt x;
                   goto_programt::targett x_ins = x.add_instruction();
                   x_ins->make_decl();
                   x_ins->code = code_declt(symbol.symbol_expr());
                 f_it->second.body.destructive_insert(i_it,x);
                             }
                        goto_programt x;
                     goto_programt::targett y_ins = x.add_instruction();
                     y_ins->make_assignment();
                      y_ins->code = code_assignt(symbol.symbol_expr(),i_it->guard);
                      y_ins->source_location = i_it->source_location;
                      y_ins->function=i_it->function;
                      goto_programt tmp_prog;
                     get_guarded_lock_gadget(tmp_prog,y_ins);
                     x.destructive_append(tmp_prog);


  //                    get_assume_unlocked_gadget(tmp_prog,y_ins);
                     goto_programt::targett next = i_it;
                     next++;

                     i_it->guard = symbol.symbol_expr();
                     f_it->second.body.insert_before_swap(i_it,x);
                    // f_it->second.body.destructive_insert(i_it,tmp_prog);
                     i_it=next;



             }
             // add the guarded lock release/acquire after access to a shared variable
             else if(
                 ( //(i_it->is_return() && i_it->function != ID_main)
                   // ||
                    has_sharedvar_access(i_it->code,context_out)
                    || has_sharedvar_access(i_it->guard,context_out))
                 && !is_builtin_instruction(i_it) && !is_pthread_method(i_it)
                 )
             {
              goto_programt tmp_prog;
               get_guarded_lock_gadget(tmp_prog,i_it);

               
#if 0

               //tmp_prog.instructions.push_back((*i_it));
               //get_guarded_lock_gadget(tmp_prog);
               if(i_it->is_return())
               {

                 goto_programt::targett next=i_it;
                 next++;
                // f_it->second.body.destructive_insert(i_it,tmp_prog);
                 f_it->second.body.insert_before_swap(i_it,tmp_prog);
                 i_it=next;

               }
#endif
      //         else
      //         {

                   i_it++;
                   f_it->second.body.destructive_insert(i_it,tmp_prog);
      //         }
              
             }
             else if(i_it->is_start_thread() || i_it->is_end_thread()
                         || (i_it->function == ID_main && i_it->is_end_function())
                         || (does_irep_id_contains_str(i_it->function,"__actual_thread_spawn")
                        		 && i_it->is_end_function()))
             {
               //if it is a start_thread/end_thread instruction or end_function in main then release the lock
               // that might have been acquired  by the earlier guarded lock gadget

               goto_programt::targett next=i_it;
               next++;

               if((does_irep_id_contains_str(i_it->function,"__actual_thread_spawn")

              		 && i_it->is_end_function()))
               {
            	   goto_programt x;
            	                 get_lock_acquire_gadget(x,i_it->function);

               f_it->second.body.insert_before_swap(i_it,x);
               }
               else
               {
                goto_programt unlock_x;
                get_lock_release_gadget(unlock_x,i_it->function);
                f_it->second.body.insert_before_swap(i_it,unlock_x);
               }

               i_it=next;
               goto_programt::targett curr_ins = i_it;
               curr_ins--;
              
               //i_it=next++;

               if(curr_ins->is_start_thread())
               {
                 

                 // if the instruction is a start_thread then have to acquire lock after start_thread (due to beginning of new thread )
                 //NOTE that curr_ins is the start_thread instruction and i_it now points to the next instruction after that for the use in destructive_insert
                 goto_programt x1;
                 get_lock_acquire_gadget(x1,curr_ins->function);

                 //since it is a start_thread instruction thread_id_gadget has to be inserted after start_thread instruction
                 //the lock_acquire will follow the thread_id_gadget
                 goto_programt x2;
                 get_thread_id_gadget(x2);

                 x2.destructive_append(x1);


               //  goto_programt x3;
                // get_lock_acquire_gadget(x3,curr_ins->function);


                 //The instruction right after START_THREAD must be unconditional goto
                                                   //the "new" thread apparently starts from after this GOTO. So anything
                                                   //between START_THREAD and this GOTO still belongs to the calling(parent) thread
                                                   assert(i_it->is_goto());

                                               //    goto_programt::targett lacq_target = i_it;
                                                //   f_it->second.body.destructive_insert(lacq_target,x3);
                                                   i_it++;i_it++;
                 f_it->second.body.destructive_insert(i_it,x2);



               }
             /*  else if(curr_ins->is_end_thread())
               {
            	   // if the instruction is end_thread then the lock has to be acquired after it for proper matching
            	   // of lock/unlock

            	   goto_programt x1;
            	   get_lock_acquire_gadget(x1,curr_ins->function);

            	 //  f_it->second.body.insert_before_swap(i_it,x1);
            	  // f_it->second.body.destructive_insert(i_it,x1);
               }*/

               

               
             }
         /*   else if(is_pthread_create(i_it))
             {
            	 i_it++;
            	 goto_programt x;
            	 get_lock_release_gadget(x,f_it->first);
            	 goto_programt x1;
            	 get_lock_acquire_gadget(x1,f_it->first);
            	 x.destructive_append(x1);
            	 goto_programt::targett next=i_it;
            	 next++;

            	 f_it->second.body.insert_before_swap(i_it,x);

            	 i_it=(next--);



             }*/
             else
             {
               //tmp_prog.instructions.push_back((*i_it));
               i_it++;
             }
           }

           if(f_it->first == ID_main)
           {
             //initialize thread_counter to zero in main
                      goto_programt init_thread_counter;
                      goto_programt::targett tc_init_instr = init_thread_counter.add_instruction();
                      tc_init_instr->make_assignment();
                      tc_init_instr->code = code_assignt(thread_counter.symbol_expr(),
                                                        from_integer(0,thread_counter.type));



                      goto_programt gadget_in_main;
                      get_lock_acquire_gadget(gadget_in_main,f_it->first);

                      goto_programt thread_id_gadget;
                      get_thread_id_gadget(thread_id_gadget);

                      //thread_id_gadget.destructive_append(gadget_in_main);
                      init_thread_counter.destructive_append(thread_id_gadget);
                      init_thread_counter.destructive_append(gadget_in_main);

                      goto_programt::targett inst = f_it->second.body.instructions.begin();

                      f_it->second.body.destructive_insert(inst,init_thread_counter);
                     // f_it->second.body.update();



           }
#if 0
           else
           {
             goto_programt tmp_prog;
             goto_programt::targett inst = f_it->second.body.instructions.begin();
             get_guarded_lock_gadget(tmp_prog,inst);

             f_it->second.body.destructive_insert(inst,tmp_prog);
           }
#endif

           f_it->second.body.update();
         }

       }
#if 0
        //Insert the atomic_begin at the start of main 
       //NOTE : This block of code must be the last. Since thread_id_gadget introduces new global/shared variables,
       // if this block is the first, then has_sharedvar_access succeeds even for the intructions introduced in the thread_id_gadget
       goto_functionst::function_mapt::iterator main_it = func_out.function_map.find(func_out.main_id());
       if(main_it!=func_out.function_map.end())
       {
         //initialize thread_counter to zero in main
         goto_programt init_thread_counter;
         goto_programt::targett tc_init_instr = init_thread_counter.add_instruction();
         tc_init_instr->make_assignment();
         tc_init_instr->code = code_assignt(thread_counter.symbol_expr(),from_integer(0,thread_counter.type));


         goto_programt gadget_in_main;
         get_lock_acquire_gadget(gadget_in_main);

         goto_programt thread_id_gadget;
         get_thread_id_gadget(thread_id_gadget);

         //thread_id_gadget.destructive_append(gadget_in_main);
         init_thread_counter.destructive_append(thread_id_gadget);
         init_thread_counter.destructive_append(gadget_in_main);

         goto_programt::targett inst = main_it->second.body.instructions.begin();

         main_it->second.body.destructive_insert(inst,init_thread_counter);
         main_it->second.body.update();
         

         
       }
       else
       {
          goto_programt tmp_prog;

          goto_programt::targett init =
               get_guarded_lock_gadget(tmp_prog,i_it);

       }

#endif

   }

   /**************************************************************************\

   Function : watomic_transformationt::get_assume_unclocked_gadget

   Input : result, instr_loc

   Output : 

   Purpose : given an instruction in instr_loc, it builds the following goto_program in result

   atomic_begin
   if($glue_wbguard_XX) GOTO L

   assume($glue_lock == 0 || $glue_lock = $glue_thread_id)
   L: instr_loc
    atomic_end


   \**************************************************************************/

   void watomic_transformationt::get_assume_unlocked_gadget(goto_programt& result, goto_programt::targett&  instr_loc)
   {
    // atomic begin
     goto_programt x;
     goto_programt::targett x_ins = x.add_instruction();
     x_ins->make_atomic_begin();
     make_auxiliary(x_ins);

         symbolt bguard;
       std::stringstream ss;
       wbguard_counter++;
       ss << GLUE_WBGUARD << wbguard_counter;
       
       const irep_idt tmp_name = ss.str();
         
       bguard.is_lvalue=true;
       bguard.is_static_lifetime = true;
       bguard.is_thread_local= false;
       bguard.type = bool_typet();
       bguard.base_name=tmp_name;
       std::stringstream ss1;
       ss1 << "c::" << ss.str();
       bguard.name=ss1.str();
       bguard.mode=ID_C;
    
       context_out.add(bguard);

    // branch instruction
     goto_programt::targett y_ins = x.add_instruction();
     make_auxiliary(y_ins);


     
     // glue_lock == 0 || glue_lock = thread_id
     exprt e = or_exprt(equal_exprt(glue_lock.symbol_expr(),from_integer(0,glue_lock.type)),
                        equal_exprt(glue_lock.symbol_expr(),thread_identifier.symbol_expr()));

     goto_programt::targett z_ins = x.add_instruction();
     z_ins->make_assumption(e);
     make_auxiliary(z_ins);

     // add the original instruction
     goto_programt::targett t_ins = x.add_instruction();
     t_ins->make_skip();
     t_ins->swap(*instr_loc);
     //since get_assume_unlocked is invoked always on ORIGINAL instruction
     //it must have a non-zero guard no from strong atomicity
     unsigned int bgno = get_guard_from_instruction(t_ins,STRONG);
     assert(bgno!=0);
     prepend_to_instruction(t_ins,GLUEUNLOCKED);
     prepend_to_instruction(t_ins,ss.str());
     //store in the map, mapping from strong to weak guard
     //this will be needed when emulating runs from guard_trace
     guard_map[bgno]=wbguard_counter;

     // make the original instruction target of the branch
     y_ins->make_goto(t_ins);
     y_ins->guard = bguard.symbol_expr();

     //atomic end
     goto_programt::targett w_ins = x.add_instruction();
     w_ins->make_atomic_end();
     make_auxiliary(w_ins);

     result.destructive_append(x);





   }
/*****************************************************************************\
 *
 * Function : watomic_transformationt::get_tmp_bool_symbol
 *
 * Input : symbol - a reference to already creatd symbol
 *         mname - name of the method in which a temporary symbol is to be
 *         created
 *
 * Output : true - if the symbol was newly created for the said method
 *          false - if the symbol already existed for the said method
 *
 * Purpose : Create a new boolean temporary symbol for a method if one
 *             does not exist already
 *****************************************************************************/
   bool transformation_passt::get_tmp_bool_symbol(symbolt& symbol,
                                                const irep_idt& mname)
   {
         std::string s = as_string(mname);
         irep_idt newvar(s+std::string(WTMPVAR));
            if(context_out.has_symbol(newvar))
            {
              symbol = context_out.lookup(newvar);
              return false;
            }
            else
            {
              symbol.name = std::string(s+std::string(WTMPVAR));
              symbol.is_lvalue=true;
              symbol.is_static_lifetime=false;
              symbol.is_thread_local=true;
              symbol.type = bool_typet();
              symbol.base_name = symbol.name;
              symbol.mode = ID_C;
                context_out.add(symbol);
                 return true;
            }

   }
/****************************************************************************
 * Function : satomic_transformationt::populated_guards_to_protect
 *
 * Input : set of unsigned int (guard no) to be protected
 *
 * Output : None
 *
 * Purpose : Initialize the filed protect_guards with the given set. THIS
 * FUNCTION MUST BE CALLED BEFORE POINTS_TO_REGION
 * **************************************************************************
 */
void satomic_transformationt::populate_guards_to_protect(const protect_guardst& s)
{
   for(protect_guardst::const_iterator it=s.begin();it!=s.end();it++)
   {
     protect_guards.insert(*it);
   }
}


/****************************************************************************
 *
 *
 * Function : satomic_transformationt::init_func_weak
 *
 * Input : None
 *
 *
 * Output : None
 *
 * Purpose : deep copy func_out to func_weak
 *
 * The reason is that once we transform and prepare the program for weak
 * atomicity synthesis, we may want to look at the traces we have seen for
 * strong atomicity search for the weak atomicity in order to reduce the
 * SAT queries fired for this weak atomicity stage. goto_trace_stept::PC
 * points to the original program for which the trance is generated.
 * Therefore, original func_out will be needed in this case.
 *
 * MUST BE CALLED INSIDE REMOVE_AUXILIARY
 * **************************************************************************
 */

void satomic_transformationt::init_func_weak()
{
  func_weak.copy_from(func_out);
}

/*****************************************************************************
 *
 * Function : satomic_transformationt::remove_auxiliary
 *
 * Input : None
 *
 * Output : None
 *
 * Purpose : satomic_transformationt::apply_transformation adds AUXILIARY
 * in the comment field of instructions that were added by the transformation
 * . This function removes all those instructions
 ****************************************************************************/
void satomic_transformationt::remove_auxiliary()
{
  init_func_weak();
   Forall_goto_functions(f_it,func_weak)
    {
        if(f_it->second.body_available)
        {
          goto_programt& p = f_it->second.body;
             Forall_goto_program_instructions(it,p)
             {
                if(is_auxiliary_instruction(it))
                {
                   it->make_skip();
                }
             }
        }
    }

  remove_skip(func_weak);
  func_weak.update();
}

/*****************************************************************************
 *
 * Function : satomic_transformationt::build_guards_to_instr_map
 *
 * Input : None
 *
 * Output : None
 *
 * Purpose : Initialize the member map guard_to_instr_map. Map from guard no
 * to the instruction
 * ***************************************************************************
 */
void satomic_transformationt::build_guard_to_instr_map()
{
   Forall_goto_functions(f_it,func_weak)
    {
        if(f_it->second.body_available)
        {
           goto_programt& p = f_it->second.body;

           Forall_goto_program_instructions(it,p)
           {
               if(is_original_instruction(it))
               {
                    unsigned int guard_no = get_guard_from_instruction(it,STRONG);
                    fname_to_instr_pairt fp(f_it->first,it);
                    guard_to_instr_map[guard_no]=fp;
               }

           }
        }
    }

}

#if 0
void satomic_transformationt::compute_dominator(const irep_idt& fname)
{

  goto_functionst::function_mapt::const_iterator it=func_weak.function_map.find(fname);

  if(it!=func_out.function_map.end() && it->second.body_available)
  {
     cfg_dominatorst cfgdom;
     cfgdom(it->second.body);
     program_to_cfg_map[it->first]=cfgdom;
  }

}
#endif




/*****************************************************************************
 *
 * Function : satomic_transformationt::print_regions
 *
 *
 * Input : std::ostream& out
 *
 * Output : None
 *
 * Purpose : print the region that is to be locked (or put inside strong
 * atomic sections)
 *****************************************************************************/
void satomic_transformationt::print_regions(std::ostream& out) const
{
  unsigned int counter=0;
  for(guard_lock_mapt::const_iterator it=guard_lock_map.begin();
      it!=guard_lock_map.end();it++)
  {
     out << "Region " << ++counter << std::endl << " ---------" << std::endl;
     for(goto_programt::const_targetst::const_iterator cit=it->second.begin();
         cit!=it->second.end();cit++)
     {
         out << (*cit)->source_location << std::endl;
     }

     out << "--------------" << std::endl;


  }
}


/*****************************************************************************
 *
 * Function : satomic_transformationt::insert_locks
 *
 * Input : None
 *
 * Output : None
 *
 * Purpose : Insert lock acquire and release gadgets to cover the regions
 * to be locked (protected through strong atomicity)
 ****************************************************************************/

void satomic_transformationt::insert_locks()
{
     for(guard_unlock_mapt::iterator it=guard_unlock_map.begin();
         it!=guard_unlock_map.end();it++)
     {
        unsigned int guard_no = it->first;

        goto_programt::targett lock_instr = guard_to_instr_map[guard_no].second;
        const irep_idt fname = guard_to_instr_map[guard_no].first;

        goto_programt& prog = func_weak.function_map[fname].body;
        goto_programt tmp_prog;
        get_lock_acquire_gadget(tmp_prog,fname);

        prog.insert_before_swap(lock_instr,tmp_prog);

        for(goto_programt::targetst::iterator tit=it->second.begin();
            tit!=it->second.end();tit++)
        {
           goto_programt tmp_prog1;
           get_lock_release_gadget(tmp_prog1,fname);

           prog.insert_before_swap(*tit,tmp_prog1);
        }

        prog.update();


     }
}

void satomic_transformationt::remove_aux_vars()
{
	for(unsigned i=1;i<= bguard_counter;i++)
	{
		std::stringstream ss;

		ss << "c::" << GLUE_BGUARD << bguard_counter;
		irep_idt sname(ss.str());
		context_out.remove(sname);

	}
}


/*****************************************************************************
 *
 *
 * Function : satomic_transformationt::point_to_region
 *
 * Input : guards_done - set of guards that have already been considered,
 *          guard_no - guard no for which the region is to be constructed
 *          prog - goto_program in which the guard appears (thus the region)
 *          local_lock - instruction from which the reachability will proceed
 *          to find if an unlocking point exist
 ****************************************************************************/

bool satomic_transformationt::point_to_region(std::set<unsigned int>& guards_done,
    const unsigned int guard_no, goto_programt& prog,
    const goto_programt::targett& local_lock)
    //,
    //std::list<goto_programt::targett>& local_unlock

{

      goto_programt::const_targetst instrs_seen;
     goto_programt::targett instr = local_lock;

     goto_programt::targetst successors;
     successors.push_back(instr);

     do
     {
        instr = successors.front();
        if(instr->type==END_FUNCTION || instr->type==RETURN) {successors.clear(); continue;}

        //if the instruction has been already seen, return with
        //appropriate results
        instr_lockstatus_mapt::iterator lmit = instr_lockstatus_map.find(instr);
         if(lmit!=instr_lockstatus_map.end())
         {
           if(lmit->second ==LOCKED)
           {
             //the instruction instr has already been recorded as LOCKED
             // so all the instruciton that we have seen in this call
             // needs to be inside the lock region
            for(goto_programt::const_targetst::const_iterator tit = instrs_seen.begin(),
                 tit_end=instrs_seen.end();tit!=tit_end;tit++)
             {
                guard_lock_map[guard_no].push_back(*tit);
             }
           }
           // update the status of local_lock to be the same as
           // instr. In one function call we only deal with
           //straight line code, so local_lock and instr will share
           // the same status.
             instr_lockstatus_map[local_lock] = lmit->second;
             return lmit->second;
         }
         //instruction has not been seen already, so push it in the local list
           instrs_seen.push_back(instr);

         if(is_original_instruction(instr))
         {

           //if the instruction is original it must be
           //from one of the guard


              prog.get_successors(instr,successors);
              //since all global access has been lifted out of a branch
              //instruction, the assertion must hold
              assert(successors.size()==1);

            //set the comment of the instruction so that watomic_transformationt
              // does not have to insert gadget for this instruction
               prepend_to_instruction(instr,GLUELOCKED);

               /**straight line code seen in this function is definitely
               //inside the locking region. This is because we begin
               //with an instruction corresponding to guard inside a
               //locking region. Now there are three possibilities,
                * (1)The guard g_no corresponding to this original instruction
                * is NOT part of the solution. In which case the next
                * instruction is definitely out of the locking region so
                * lock release must be inserted before the next instruction.
                *
                * (2) The guard g_no is equal to guard_no : this will happen
                * for the first call from points_to_region. In this case
                * we want to know if the next instruction onwards
                * any unlock point is reached.
                *
                * (3) g_no and guard_no are different : In this case
                *   if the next instruction can not reach an unlock point
                *   then lock release has to be inserted before the next instruction
                *
                * In any case, the instruction seen in this function
                * has to be part of the locking region
                *
                * **/
              instr_lockstatus_map[local_lock]=LOCKED;
              instr_lockstatus_map[instr]=LOCKED;

              //as mentioned earlier, the next instruction has to be outside
              //therefore unlock needs to be performed prior to this next instruction
              unsigned int g_no = get_guard_from_instruction(instr,STRONG);
              assert(g_no!=0);
              for(goto_programt::const_targetst::const_iterator tit = instrs_seen.begin(),
                                            tit_end=instrs_seen.end();tit!=tit_end;tit++)
                {
                //for all the instruction seen in this basic block, put it inside
                //the locking region
                    guard_lock_map[guard_no].push_back(*tit);
                }
              goto_programt::targett& new_instr = successors.front();

              //guard_to_instr_mapt::iterator git= guard_to_instr_map.find(g_no);


              protect_guardst::iterator git=protect_guards.find(g_no);
                         if(git==protect_guards.end())
                         {
                           //if the guard is not to be protected, unlocking should be done here
                              guard_unlock_map[guard_no].push_back(new_instr);

                         }
                         else
                           {
                           //if the guard is to be protected, mark it as done and proceed
                            //The reason why recursion is applied here is because if  starting from
                           //this instruction, if we do not find an unlocking point then we
                           //need to unlock here (at new_instr)
                              guards_done.insert(g_no);
                              bool lstatus = point_to_region(guards_done,guard_no,prog,new_instr);
                              if(lstatus==UNLOCKED)
                              {
                               guard_unlock_map[guard_no].push_back(new_instr);
                              }
                            }
                         return LOCKED;




            }



         prog.get_successors(instr,successors);


     }while(successors.size()==1);


     if(successors.size()==0)
     {
       //we have reached the end of the function
       //therefore all the instruction seen in this function call
       //must be outside the locking region

       instr_lockstatus_map[local_lock]=UNLOCKED;
       instr_lockstatus_map[instr]=UNLOCKED;
       return UNLOCKED;

     }
     else
     {
       //There are more than one successor, so recurse for
       //each brach target

       bool is_any_locked=false;

       typedef std::map<goto_programt::targett,bool> branch_lockstatus_mapt;
       branch_lockstatus_mapt branch_lockstatus_map;

       for(goto_programt::targetst::iterator bit=successors.begin(),
           bit_end=successors.end();bit!=bit_end;bit++)
       {
           bool result = point_to_region(guards_done,guard_no,prog,(*bit));
           is_any_locked |=result;


             branch_lockstatus_map[*bit]=result;



       }

       if(is_any_locked)
       {
       //if one of the branch reaches a proper unlocking point
         //unlocking has to be performed for all the other branch
          for(branch_lockstatus_mapt::iterator mit=branch_lockstatus_map.begin();
              mit!=branch_lockstatus_map.end();mit++)
          {

            if(mit->second==UNLOCKED)
            {
              guard_unlock_map[guard_no].push_back(mit->first);
            }

          }

          //since one of the branch reaches a proper unlocking point
          //all the instruction in this basic block (function call) is also
          //part of the locking region
          for(goto_programt::const_targetst::const_iterator tit = instrs_seen.begin(),
                           tit_end=instrs_seen.end();tit!=tit_end;tit++)
           {
             guard_lock_map[guard_no].push_back(*tit);
           }
          instr_lockstatus_map[local_lock]=LOCKED;
          instr_lockstatus_map[instr]=LOCKED;

          return LOCKED;

       }
       else
       {//none of the branch reached unlocking point
         //so all the instruction seen in this function call
         //is outside the lockin region
         instr_lockstatus_map[local_lock] = UNLOCKED;
         instr_lockstatus_map[instr] = UNLOCKED;
         return UNLOCKED;
       }

     }

}


/*****************************************************************************
 *
 * Function : satomic_transformationt::points_to_regions
 *
 * Input : NOne
 *
 * Output : None
 *
 * Purpose : starting from every guard that needs to be protected, construct
 * the region that needs to be protected
 * ***************************************************************************
 */
void satomic_transformationt::points_to_regions()
{

   std::set<unsigned int> guards_done;
   for(protect_guardst::const_iterator pit = protect_guards.begin();
       pit!=protect_guards.end();pit++)
    //for(guard_to_instr_mapt::const_iterator it=guard_to_instr_map.begin(),
     //   it_end=guard_to_instr_map.end();it!=it_end;it++)
    {

        unsigned int guard_no = (*pit);

        if(guards_done.find(guard_no)!=guards_done.end())
        {
          continue;
        }
       // guards_done.insert(guard_no);
        //compute_dominator(fname);
        goto_programt::targett guard_instr= guard_to_instr_map[guard_no].second;
               const irep_idt fname = guard_to_instr_map[guard_no].first;

               goto_programt::const_targetst instr_inside_lock;
               goto_programt::targetst instr_to_unlock;
               guard_lock_map[guard_no]=instr_inside_lock;
               guard_unlock_map[guard_no]=instr_to_unlock;

               assert(func_weak.function_map[fname].body_available==true);
               goto_programt& prog= func_weak.function_map[fname].body;

        goto_programt::targett& local_lock = guard_instr;
        std::list<goto_programt::targett> local_unlock;


       bool result= point_to_region(guards_done,guard_no,prog,local_lock);
       if(!result)
       {
         //if no other access to shared variable reachable from here
         // just protect this one instruction. unlock gadget needs to be
         // inserted before the instructions in guard_unlock_map
          guard_unlock_map[guard_no].push_back(++local_lock);

       }




    }

}



void satomic_transformationt::construct_regions(const protect_guardst& s)
{
  populate_guards_to_protect(s);
  remove_auxiliary();
  build_guard_to_instr_map();
  points_to_regions();
  insert_locks();
  remove_aux_vars();
}

      /************************************************************************************************
     Function : watomic_transformationt::apply_transformation

     Input : None

     Output : None

     Purpose : func_out will contain the transformed program at the end. It must take a set of program
     points to guard inside a locked region. The rest of the program points will be guarded by assume
     which will make sure that an access happens only if lock is not held. This assumes can be enabled
     or disabled through guards
     ************************************************************************************************/
void watomic_transformationt::apply_transformation()
   {
     
        


       Forall_goto_functions(f_it,func_out)
       {
         if(f_it->second.body_available)
         {
          Forall_goto_program_instructions(i_it,f_it->second.body)
           {
             if(is_original_instruction(i_it) &&
                 !does_instr_contain(i_it,GLUELOCKED) &&
                 i_it->type!=FUNCTION_CALL &&
                 !does_irep_id_contains_str(i_it->function,"__CPROVER") &&
                 ((i_it->type!=ASSUME) ||
                     !does_expr_uses_symbol_containing(i_it->guard,"__CPROVER_threads_exited") ))
             {

               //the instruction not already locked and not
               // a function call.
               // so introduce the gadget

               std::cout << "*** " << i_it->function << "****" << std::endl;
                 goto_programt tmp_prog;
                 get_assume_unlocked_gadget(tmp_prog,i_it);
                 f_it->second.body.destructive_insert(i_it,tmp_prog);
               


             }
           }


          // f_it->second.body.update();
         }

         remove_skip(func_out);
         func_out.update();

       }


   }
/*****************************************************************************\
 *
 * Function : watomic_transformationt::simulate_guard_trace
 *
 * Input : guard_trace : trace in form of guards and thread switches abstracted
 *          from goto_trace resulted from earlier queries
 *        , csguards : boolean guards that needs to be protected for strong
 *        atomicity
 * Output :  lprotect : set of locations that needs to be protected when
 *        visited from proposed strong atomicity regions (these locations
 *        are in conflict with the context switches that needs to be protected)
 *
 * Purpose : simulate the run of guard_trace and extract the set of locations (lprotect)
 *           that were visited from inside the proposed strong atomicity regions
 *           (represented by csguards)
 *
 *           The method works as follows. Wait till the context switch happens,
 *           if the context switch is from the csguards then all the locations
 *           thereafter needs to be tracked (set flag to true and remember the thread_nr
 *           of the source thread). Keep tracking the locations until you return back to
 *           the same thread again.
 *
 *           Finally the border condition could be that the guard_trace might end but
 *           flag is still set to true (you are inside a proposed strong atomicity region
 *           and the assertion has failed) in which case the last location (wbguards) also needs to
 *           be in lprotect
 *
 *
 *
 */
void watomic_transformationt::simulate_guard_trace(const uisett& guard_trace,
    const std::set<unsigned int>& csguards,
    cpointst& lprotect)
{
  lprotect.clear();

  for(uisett::const_iterator git=guard_trace.begin();
		  git!=guard_trace.end();git++)
  {
	  // if the guard is already protected by satomic than this trace
	  // is already hit/covered by locks of satomic
	  if(csguards.find(*git)!=csguards.end())
	  {
            lprotect.clear();
            return;
	  }

		  guard_mapt::iterator gmit=guard_map.find(*git);
		  if(gmit!=guard_map.end())
		  {
			  lprotect.insert(gmit->second);
		  }

  }


#if 0
  guard_tracet::const_iterator tit = guard_trace.begin();
  guard_tracet::const_iterator tit_end = guard_trace.end();
  guard_tracet::const_iterator next = tit;
  next++;

  unsigned int thread_nr=0;
  bool flag=false;
  while(next!=tit_end)
  {

    if(flag)
    {
      if(tit->second!=0)
      {
        guard_mapt::iterator git = guard_map.find(tit->second);
        if(git!=guard_map.end())
        {
          lprotect.insert(git->second);
        }
      }

      if(tit->first!=next->first && next->second==thread_nr)
      {
        flag=false;
      }

    }
    else
    {
      if(tit->first!=next->first && tit->first!=0)
      {
        std::set<unsigned int>::iterator sit=csguards.find(tit->second);
        if(sit!=csguards.end())
        {
          flag=true;
          thread_nr=tit->first;
        }
      }

    }
    tit=next;
    next++;

  }
  if(flag)
     {
       if(tit->second!=0)
       {
         guard_mapt::iterator git = guard_map.find(tit->second);
         if(git!=guard_map.end())
         {
           lprotect.insert(git->second);
         }
       }
     }


#endif
  }

/*****************************************************************************\
 *
 */
void watomic_transformationt::simulate_guard_traces(
    const cpoints_collectiont& guard_traces,
    const std::set<unsigned int>& csguards
    )
{
  for(cpoints_collectiont::const_iterator gtit=guard_traces.begin();
      gtit!=guard_traces.end();gtit++)
  {
    std::set<unsigned int> s;

    simulate_guard_trace((*gtit),csguards,s);
    if(!s.empty())
    {
     cpoints_collection.push_back(s);
    }
  }
}

void watomic_transformationt::print_guard_trace(const guard_tracet& guard_trace,
		std::ostream& out)
{
	out << "Trace begin" << std::endl;
	for(guard_tracet::const_iterator git=guard_trace.begin();
			git!=guard_trace.end();git++)
	{
		out << git->first << ":" << git->second << "   ";
	}
	out << std::endl;
}

#if 0
void watomic_transformationt::apply_transformation()
   {




       Forall_goto_functions(f_it,func_out)
       {
         if(f_it->second.body_available)
         {
          // forall_goto_program_instructions(i_it,f_it->second.body)
           //CAN NOT use forall_goto_program_instructions macro
           // because increase in iterator value is non-uniform.
           // the increase happens before the lock gadget is inserted
           //where as it happens after in other cases
           goto_programt::instructionst::iterator i_it = f_it->second.body.instructions.begin();
           while(i_it!=f_it->second.body.instructions.end())
           {
             // add the guarded lock release/acquire after access to a shared variable

             if( i_it->is_goto() && ! is_builtin_instruction(i_it) && has_sharedvar_access(i_it->guard,context_out) )
             {
               symbolt symbol;
               if(get_tmp_bool_symbol(symbol,i_it->function))
               {
                 goto_programt x;
                 goto_programt::targett x_ins = x.add_instruction();
                 x_ins->make_decl();

                 x_ins->code = code_declt(symbol.symbol_expr());
                  f_it->second.body.destructive_insert(i_it,x);
               }

                    goto_programt x;
                 goto_programt::targett y_ins = x.add_instruction();
                 y_ins->make_assignment();
                 y_ins->code = code_assignt(symbol.symbol_expr(),i_it->guard);

                 goto_programt tmp_prog;
                 get_assume_unlocked_gadget(tmp_prog,y_ins);
                 f_it->second.body.destructive_insert(i_it,tmp_prog);
                 i_it->guard = symbol.symbol_expr();




             }
             //Note that this condition can be satisfied when
             //the condition for "if" above is satisfied as well. However, else if
             //prevents evaluation of this condition again. Preserve
             // the order of if-else if conditions
             else if( !is_builtin_instruction(i_it) && (has_sharedvar_access(i_it->code,context_out)
                 || has_sharedvar_access(i_it->guard,context_out)))
                          {
                           goto_programt tmp_prog;
                           get_assume_unlocked_gadget(tmp_prog,i_it);




                            i_it++;
                            f_it->second.body.destructive_insert(i_it,tmp_prog);

                          }


#if 0
             else if(i_it->is_start_thread() || i_it->is_end_thread() || (i_it->function == ID_main && i_it->is_end_function()))
             {
               //if it is a start_thread/end_thread instruction or end_function in main then release the lock
               // that might have been acquired  by the earlier guarded lock gadget
               goto_programt x;
               get_lock_release_gadget(x);

               f_it->second.body.destructive_insert(i_it,x);

               goto_programt::targett curr_ins = i_it;

               i_it++;

               if(curr_ins->is_start_thread())
               {


                 // if the instruction is a start_thread then have to acquire lock after start_thread (due to beginning of new thread )
                 //NOTE that curr_ins is the start_thread instruction and i_it now points to the next instruction after that for the use in destructive_insert
                 goto_programt x1;
                 get_lock_acquire_gadget(x1);

                 //since it is a start_thread instruction thread_id_gadget has to be inserted after start_thread instruction
                 //the lock_acquire will follow the thread_id_gadget
                 goto_programt x2;
                 get_thread_id_gadget(x2);

                 x2.destructive_append(x1);

                 f_it->second.body.destructive_insert(i_it,x2);
               }




             }
#endif
             else
             {
               //tmp_prog.instructions.push_back((*i_it));
               i_it++;
             }
           }

           f_it->second.body.update();
         }

       }
#if 0
        //Insert the atomic_begin at the start of main
       //NOTE : This block of code must be the last. Since thread_id_gadget introduces new global/shared variables,
       // if this block is the first, then has_sharedvar_access succeeds even for the intructions introduced in the thread_id_gadget
       goto_functionst::function_mapt::iterator main_it = func_out.function_map.find(func_out.main_id());
       if(main_it!=func_out.function_map.end())
       {
         //initialize thread_counter to zero in main
         goto_programt init_thread_counter;
         goto_programt::targett tc_init_instr = init_thread_counter.add_instruction();
         tc_init_instr->make_assignment();
         tc_init_instr->code = code_assignt(thread_counter.symbol_expr(),from_integer(0,thread_counter.type));


         goto_programt gadget_in_main;
         get_lock_acquire_gadget(gadget_in_main);

         goto_programt thread_id_gadget;
         get_thread_id_gadget(thread_id_gadget);

         //thread_id_gadget.destructive_append(gadget_in_main);
         init_thread_counter.destructive_append(thread_id_gadget);
         init_thread_counter.destructive_append(gadget_in_main);

         goto_programt::targett inst = main_it->second.body.instructions.begin();

         main_it->second.body.destructive_insert(inst,init_thread_counter);



       }

#endif

   }

#endif
