#ifndef CPROVER_GLUE_EXPR_UTIL_H
#define CPROVER_GLUE_EXPR_UTIL_H


#include <iostream>
#include <string>
#include <util/expr.h>
#include <util/symbol_table.h>
#include <util/symbol.h>
#include <util/expr_util.h>
#include <util/std_expr.h>
#include <cbmc/bv_cbmc.h>
//#include <glue/glue_transformation.h>
/* added by sbjoshi*/
#include <goto-programs/goto_trace.h>
#include <goto-symex/partial_order_concurrency.h>

#define GLUEAUX "Auxiliary: "
#define GLUEORIG "Original: "

#define GLUELOCKED "LOCKED: "
#define GLUEUNLOCKED "UNLOCKED: "

#define GLUELOCKING "LOCKING: "
#define GLUEUNLOCKING "UNLOCKING: "

#define GLUE_BGUARD "$glue_bguard_"
#define GLUE_WBGUARD "$glue_wbguard_"

#define GLUE_GROUP_SYMBOL "$glue_group_symbol__"
typedef enum{STRONG,WEAK} atomicityt;
typedef std::pair<unsigned int,unsigned int> pair_uint;
typedef std::list<pair_uint> guard_tracet;

typedef std::set<unsigned int> uisett;

/*! \copydoc has_sharedvar_access(const exprt&, const contextt&) */
bool has_sharedvar_access(const exprt &expr,const symbol_tablet& context);


unsigned int get_guard_from_trace_step(const goto_trace_stept& e,atomicityt a);
void get_conflict_points_from_trace(const goto_tracet&goto_trace,
    std::set<unsigned int>& cpoints);
void extract_conflict_points(const guard_tracet& guard_trace,
		std::set<unsigned int>& cpoints,const unsigned int thread_nr,
		unsigned int cs);
void get_cstaken_from_trace(const goto_tracet& goto_trace,
    std::set<unsigned int>& cs_taken,
    std::set<unsigned int>& cpoints);

bool is_builtin_instruction(const goto_programt::targett& instr);
void make_auxiliary(goto_programt::targett& instr);
void make_original(goto_programt::targett& instr);
bool is_auxiliary_instruction(const goto_programt::targett& instr);
bool is_auxiliary_instruction(const goto_programt::const_targett& instr);
unsigned int get_guard_from_instruction(const goto_programt::const_targett& instr,atomicityt a);
bool is_original_instruction(const goto_programt::const_targett& instr);
void prepend_to_instruction(goto_programt::targett& instr,const  std::string str);
bool does_instr_contain(const goto_programt::const_targett& instr, const std::string str);
bool does_irep_id_contains_str(const irep_idt& id,const std::string& s);
bool does_expr_uses_symbol_containing(const exprt& expr,const std::string& s);

inline const irep_idt address_of(const partial_order_concurrencyt::event_it& e)
{
  return e->original_lhs_object.get_identifier();
}
bool is_pthread_method(const goto_programt::targett& instr);
bool is_built_in_event(const partial_order_concurrencyt::eventt &e1,const partial_order_concurrencyt::eventt &e2);

bool is_in_conflict(const prop_convt& prop, const bvt& assumptions);

#endif
