#include "mhs.h"

void mhst::add_to_collection(sett& s)
	{
		//copy(s.begin(),s.end(),std::ostream_iterator<T>(std::cout," "));
		collection.push_back(s);
		//print_collection(std::cout);
	   typename std::vector<sett>::size_type vsize = collection.size();

		for(typename sett::const_iterator it=s.begin(); it!=s.end();it++)
		{
			
			if(freq_map.find(*it)!=freq_map.end())
			{
				freq_map[*it]++;
			}
			else
			{
				freq_map[*it] = 1;
			}
			
			if(elem_to_set.find(*it)!=elem_to_set.end())
			{
				elem_to_set[*it].insert(vsize-1);
			}
			else
			{
				std::set<unsigned int> s;
				s.insert(vsize-1);
				elem_to_set[*it]=s;
			}
			//universe.add(*it);
		}

	
	}

	void mhst::print_freq_map(std::ostream& os,const freq_mapt& fmap) const
	{

		os << "Freq map begin " << std::endl;
		for(typename freq_mapt::const_iterator it=fmap.begin();it!=fmap.end();it++)
		{
			os << it->first << " : " << it->second << " :: ";
		}
		os << std::endl << "freq map end" << std::endl;
	}

	void mhst::print_collection(std::ostream& os) const
	{
		os << "Printing collection start" << std::endl;

		for(typename collectiont::const_iterator it=collection.begin();it!=collection.end();it++)
		{
			for(typename sett::const_iterator sit=it->begin();sit!=it->end();sit++)
			{
				os << (*sit) << " ";
			}
			os << std::endl;

		}
		os << "printing collection end" << std::endl;
	}

	void mhst::update_freq_map(freq_mapt& fmap, const T&e) 
	{
		const std::set<unsigned int>& covered_by_elem = elem_to_set[e];

		for(std::set<unsigned int>::const_iterator it = covered_by_elem.begin();it!=covered_by_elem.end();it++)
		{
			const sett& curr_set = collection[*it];

			for(typename sett::const_iterator cit=curr_set.begin();cit!=curr_set.end();cit++)
			{
				if(fmap[*cit]>1)
				{
						fmap[*cit]--;
				}
				else
				{
					fmap[*cit]=0;
				}

			}
		}
	}

	void mhst::get_max_freq_elem(const freq_mapt& fmap,T& e) const
	{
		unsigned int max_val = std::numeric_limits<unsigned int>::min();

		//std::cout <<"Entering get_max_freq_elem : " << max_val  << std::endl; 
		for(typename freq_mapt::const_iterator it = fmap.begin();it!=fmap.end();it++)
		{
			if(it->second > max_val)
			{
			//	std::cout << it->first << " : " << it->second << " " ;
				e = it->first;
				max_val = it->second;
			}
		}

	}
	
	bool mhst::is_cover(const sett& sol,const  T& e) 
	{
		 //std::cout << "is_covered called with " << e << std::endl;
		std::set<unsigned int> covered;
		for(typename sett::const_iterator it=sol.begin();it!=sol.end();it++)
		{
			if(*it == e)
				{ continue;
			}  

			for(std::set<unsigned int>::const_iterator cit=elem_to_set[*it].begin();cit!=elem_to_set[*it].end();cit++)
			{
				covered.insert(*cit);
			}
		}
		//std::copy(covered.begin(),covered.end(),std::ostream_iterator<T>(std::cout," "));
		//std::cout << std::endl;
		if(covered.size()==collection.size())
		{
			return true;
		}
		else
		{
			return false;
		}
	}

	void get_freq_map(freq_mapt& fmap) const
	{
		for(typename freq_mapt::const_iterator it=freq_map.begin();it!=freq_map.end();it++)
		{
			fmap[it->first] = it->second;
		}
	}

	bool mhst::is_cover(const sett& sol) 
	{
		std::set<unsigned int> covered;
		for(typename sett::const_iterator it=sol.begin();it!=sol.end();it++)
		{
			

			for(std::set<unsigned int>::const_iterator cit=elem_to_set[*it].begin();cit!=elem_to_set[*it].end();cit++)
			{
				covered.insert(*cit);
			}
		}

		if(covered.size()==collection.size())
		{
			return true;
		}
		else
		{
			return false;
		}
	}

	
	void mhst::make_minimal(sett& sol) 
	{
		sett elem_to_be_removed;
		for(typename sett::const_iterator it=sol.begin();it!=sol.end();it++)
		{
			if(is_cover(sol,*it))
			{
				
				sol.erase(*it);
			}
			
			
		}

		

	}

	void mhst::get_mhs(sett& mhs)
	{
		freq_mapt new_fmap;
		get_freq_map(new_fmap);

		while(!is_cover(mhs))
		{
	//		print_freq_map(std::cout,new_fmap);
			T e;
			get_max_freq_elem(new_fmap,e);
			
			mhs.insert(e);
			//std::copy(mhs.begin(),mhs.end(),std::ostream_iterator<T>(std::cout," "));
			update_freq_map(new_fmap,e);

		}
//std::copy(mhs.begin(),mhs.end(),std::ostream_iterator<T>(std::cout," "));
		make_minimal(mhs);
//std::copy(mhs.begin(),mhs.end(),std::ostream_iterator<T>(std::cout," "));
	}