/*
 * wmm_repair.h
 *
 *  Created on: 23 Sep 2013
 *      Author: joshi
 */

#ifndef WMM_REPAIR_H_
#define WMM_REPAIR_H_

#include <map>
#include <utility>
#include "../util/irep.h"

#include "../util/symbol.h"
#include "../util/expr.h"
#include "../util/expr_util.h"
#include "../util/irep_ids.h"
#include "../goto-symex/partial_order_concurrency.h"
#include "../glue/glue_util.h"


#define GLUEWMMREPAIR "glue::wmm_repair_"

#define GLUEREPAIRSTR "wmmrepair"

typedef std::list<literalt> literalst;
typedef std::pair<partial_order_concurrencyt::event_it,
            partial_order_concurrencyt::event_it> peventt;
  typedef std::map<irep_idt,peventt > symbol2ordert		  ;
  typedef std::map<irep_idt,unsigned int> symbol2grpt;
   // symbol2grpt symbol2grp;
    typedef std::vector<literalst> orderingliteralst;
   // orderingliteralst oliterals;
    typedef std::map<literalt,irep_idt> literal2symbolt;
   // literal2symbolt literal2symbol;
    typedef std::map<irep_idt,irep_idt> sym2grpsymt;
    typedef std::vector<literalt> grp2grplitt;



class wmm_repairt
{


public:


  wmm_repairt(symbol2ordert& sym_o):ordering_counter(0),symbol2order(sym_o)
  {
    symbol2order.clear();

  };

  void optimize_constraints(symex_target_equationt& equation);
protected:
  unsigned int ordering_counter;
  symbol2ordert& symbol2order;

  symbol_exprt get_ordering_symbol();
  inline const irep_idt address_of(partial_order_concurrencyt::event_it& e) const;

};



#endif /* WMM_REPAIR_H_ */
